﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Charting;

namespace SilverlightApplication17
{
    public partial class BindDateTime : UserControl
    {
        public BindDateTime()
        {
            InitializeComponent();

            RadChart2.ItemDataBound += new EventHandler<ChartItemDataBoundEventArgs>(RadChart2_ItemDataBound);

            var data = new List<MyDateObj>() 
            {
                new MyDateObj(99.98, new DateTime(2010, 4, 30)),
                new MyDateObj(99.98, new DateTime(2010, 5, 31)),
                new MyDateObj(99.98, new DateTime(2010, 6, 30)),
                new MyDateObj(100, new DateTime(2010, 7, 31)),
                new MyDateObj(99.73, new DateTime(2010, 8, 31)),
                new MyDateObj(99.95, new DateTime(2010, 9, 30)),
                new MyDateObj(99.98, new DateTime(2010, 10, 31)),
                new MyDateObj(99.56, new DateTime(2010, 11, 30)),
                new MyDateObj(99.92, new DateTime(2010, 12, 31)),
                new MyDateObj(100, new DateTime(2010, 1, 31)),
                new MyDateObj(99.91, new DateTime(2010, 2, 28)),
                new MyDateObj(99.92, new DateTime(2010, 3, 31))
            };

            this.SetMappings(RadChart1);
            RadChart1.SeriesMappings[0].ItemMappings.Add(new ItemMapping("FormattedDate", DataPointMember.XCategory));

            this.SetMappings(RadChart2);

            RadChart1.ItemsSource = data;
            RadChart2.ItemsSource = data;
        }

        void RadChart2_ItemDataBound(object sender, ChartItemDataBoundEventArgs e)
        {
            e.DataPoint.XCategory = (e.DataItem as MyDateObj).Date.ToString("MMM-yy");
        }

        private void SetMappings(RadChart chart)
        {
            SeriesMapping seriesMapping = new SeriesMapping();
            seriesMapping.SeriesDefinition = new BarSeriesDefinition();
            seriesMapping.ItemMappings.Add(new ItemMapping("Value", DataPointMember.YValue));
            chart.SeriesMappings.Add(seriesMapping);
        }


    }

    public class MyDateObj
    {
        public double Value { get; set; }
        public DateTime Date { get; set; }
        public string FormattedDate
        {
            get
            {
                return this.Date.ToString("MMM-yy");
            }
        }

        public MyDateObj(double value, DateTime date)
        {
            this.Value = value;
            this.Date = date;
        }
    }

}
